# Copyright (C) 1999, 2000 Jay Beale
# Licensed under the GNU General Public License


package Bastille::Apache;
use lib "/usr/lib";

use Bastille::API;

@ENV="";
$ENV{PATH}="";
$ENV{CDPATH}=".";
$ENV{BASH_ENV}="";

# TO DO:
#
# 1. Write ConfigureSSL

#######################################################################
##                              HTTP/APACHE                          ##
#######################################################################

&DeactivateApacheServer;
&LimitListeningInterfaces;
#&ModifyAccessconf;
#&ConfigureSSL;


sub DeactivateApacheServer {

    if ( $GLOBAL_CONFIG{"Apache"}{"apacheoff"} eq "Y" ) {

	&ActionLog("# sub DeactivateApacheServer\n");

	&B_chkconfig_off ("httpd");

    }

}

sub LimitListeningInterfaces {

    if (($GLOBAL_CONFIG{"Apache"}{"bindapachelocal"} eq "Y") or ($GLOBAL_CONFIG{"Apache"}{"bindapachenic"} eq "Y")) {
	
	&ActionLog("# sub LimitListeningInterfaces\n");

	# First, figure out which configuration file to modify...
	
	my $httpd_file=$GLOBAL_FILE{"httpd.conf"};

	# Bind Apache to a particular interface or to the loopback device.

	if ($GLOBAL_CONFIG{"Apache"}{"bindapachenic"} and ($GLOBAL_CONFIG{"Apache"}{"bindapacheaddress"} =~ /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/) ) {
	    my $listen_ip=$GLOBAL_CONFIG{"Apache"}{"bindapacheaddress"};
	    
	    &B_replace_line($httpd_file,"Listen","Listen ${listen_ip}:80\n");
	}
	elsif ($GLOBAL_CONFIG{"Apache"}{"bindapachelocal"} eq "Y") {
	    &B_replace_line($httpd_file,"Listen","Listen 127.0.0.1:80\n");
	}
	else {
	    &ErrorLog("Some weirdness in trying to limit Apache's listening interfaces.  Probably, you tried to bind Apache to a particular interface, but did not specify a valid interface number...\n");
	}

    }
}

sub ModifyAccessconf {

    if ( ($GLOBAL_CONFIG{"Apache"}{"symlink"} eq "Y") or ($GLOBAL_CONFIG{"Apache"}{"ssi"} eq "Y") or ($GLOBAL_CONFIG{"Apache"}{"cgi"} eq "Y") or ($GLOBAL_CONFIG{"Apache"}{"apacheindex"} eq "Y" ) ) {
	
	&ActionLog("# sub ModifyAccessconf\n");
	# Editting access.conf for safer settings
	
	# Disable FollowSymLinks to prevent users linking world readable/user 
	# readable files to allow viewing/access by the server.
	#
	# Deactivate Server Side includes
	# Deactivate CGI scripts
	# Deactivate generation of indexes for directories that don't have them


	my $access_file = $GLOBAL_FILE{"httpd_access.conf"};
	my $new_options_line="Options ";

	unless ($GLOBAL_CONFIG{"Apache"}{"apacheindex"} eq "Y") {
	    $new_options_line .= "Indexes ";
	}
	unless ($GLOBAL_CONFIG{"Apache"}{"ssi"} eq "Y" ) {
	    $new_options_line .= "Includes ";
	}
	unless ($GLOBAL_CONFIG{"Apache"}{"symlink"} eq "Y" ) {
	    $new_options_line .= "FollowSymLinks ";
	}
	$new_options_line .= "\n";

	&B_replace_line ($access_file,"^[^#]*Options.*Includes",$new_options_line);
	if ($GLOBAL_CONFIG{"Apache"}{"cgi"} eq "Y") {
	    &B_hash_comment_line($access_file,"Options.*ExecCGI");
	}
    }

}


1;
