# Copyright (C) 1999, 2000 Jay Beale
# Licensed under the GNU General Public License

package Bastille::Sendmail;
use lib "/usr/lib";

use Bastille::API;
@ENV="";
$ENV{PATH}="";
$ENV{CDPATH}=".";
$ENV{BASH_ENV}="";

## TO DO: Generalize Sendmail.pm to other distros...
##


#######################################################################
##                               Sendmail                            ##
#######################################################################

# It is very important to note that each of these subroutines represent
# an OPTIONAL configuration mode.  Different options work for different
# types of machines.  A web server may only need to process outgoing
# mail to other systems and internal only mail, say, to process
# error messages going out via email.  A corporate mail server, on the
# other hand, has other needs.

&DeactivateDaemonMode;
&RunSendmailViaCron;
#&InstallFetchmail;
#&InstallPostfix;
&ResistUsernameRecon;
&RestrictRelaying;


## TODO: Remove Redhat/mandrake... dependence below: these next two only work on redhat-like things...

sub DeactivateDaemonMode {

    if (($GLOBAL_CONFIG{"Sendmail"}{"sendmaildaemon"} eq "N") and ($GLOBAL_CONFIG{"Sendmail"}{"sendmailcron"} ne "Y") ) {
	&ActionLog("# sub DeactiveDaemonMode\n");
	&B_chkconfig_off("sendmail");
   }
}

sub RunSendmailViaCron {

    if ( $GLOBAL_CONFIG{"Sendmail"}{"sendmailcron"} eq "Y" ) {
	&ActionLog("# RunSendmailViaCron\n");

	&B_replace_line("/etc/sysconfig/sendmail","DAEMON=yes","DAEMON=no\n");
	&B_replace_line("/etc/sysconfig/sendmail","QUEUE=","QUEUE=15m\n");

   }

}

sub InstallFetchmail {
   #&ActionLog("# sub InstallFetchmail\n");
#
# Offer to install fetchmail...  DOES SOMEONE WANT TO DO THIS?
#
}

sub InstallPostfix {
   #&ActionLog("# sub InstallPostfix\n");
#
# Offer to switch to postfix...  DOES SOMEONE WANT TO DO THIS?
#

}


sub ResistUsernameRecon {

    if ($GLOBAL_CONFIG{"Sendmail"}{"vrfyexpn"} eq "Y") {

	&ActionLog("# sub ResistUsernameRecon\n");
	# Disable sendmail's vrfy and expn commands

	&B_replace_line("/etc/sendmail.cf","^O Privacy","O PrivacyOptions=goaway\n");

    }

}

sub RestrictRelaying {
   &ActionLog("# sub RestrictRelaying\n");
   # Restrict relaying

   ## RH 6.0 already has this done -- remember it for other distros.
   
   #### Is there anything additional we should do here?
}



1;
